﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OptimisationManagerExtention.Model.DirectoryManagers
{
    class OptimisationExtentionWorkingDirectory
    {
        public OptimisationExtentionWorkingDirectory(string DirectoryName)
        {
            DirectoryRoot = CreateIfNotExists(DirectoryName);
            Configs = CreateIfNotExists(Path.Combine(DirectoryName, "Configs"));
            Reports = CreateIfNotExists(Path.Combine(DirectoryName, "Reports"));
        }

        public DirectoryInfo DirectoryRoot { get; }

        public DirectoryInfo Configs { get; }

        public DirectoryInfo Reports { get; }

        protected DirectoryInfo CreateIfNotExists(string path)
        {
            DirectoryInfo ans = new DirectoryInfo(path);
            if (!ans.Exists)
                ans.Create();
            return ans;
        }
    }
}
