﻿using System.Collections.Generic;

namespace OptimisationManagerExtention.Model.OptimisationManager
{
    /// <summary>
    /// Фабрика для создания классов упрамляющих процессом оптимизации
    /// </summary>
    abstract class OptimisationManagerFabric
    {
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="ManagerName">Имя создаваемого менеджера оптимизаций</param>
        public OptimisationManagerFabric(string ManagerName)
        {
            this.ManagerName = ManagerName;
        }
        /// <summary>
        /// Имя отражающее тип создаваемого менеджера оптимизации (в чем его особеность)
        /// </summary>
        public string ManagerName { get; }
        /// <summary>
        /// Метод создающий менеджера оптимизации
        /// </summary>
        /// <returns>Менеджер оптимизации</returns>
        public abstract OptimisationManager Create(Dictionary<string, BotParamKeeper> botParamsKeeper,
                                                   List<ViewModel.TerminalAndBotItem> selectedTerminals);
    }
}
