﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using OptimisationManagerExtention.Model.FileReaders;

namespace OptimisationManagerExtentionTests
{
    [TestClass]
    public class ReportReaderTest
    {
        private static string ReportName = $"{Environment.CurrentDirectory}\\Report.xml";
        private static ReportReader reader;
        private readonly Comparer_Report comparer = new Comparer_Report();

        [ClassInitialize]
        public static void SetUp(TestContext testContext)
        {
            if (File.Exists(ReportName))
                File.Delete(ReportName);

            using (var file = File.Create(ReportName))
            {
                byte[] fileData = Encoding.UTF8.GetBytes(@"<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>
<?mso-application progid=""Excel.Sheet""?>
<Workbook xmlns=""urn:schemas-microsoft-com:office:spreadsheet""
xmlns:o=""urn:schemas-microsoft-com:office:office""
xmlns:x=""urn:schemas-microsoft-com:office:excel""
xmlns:ss=""urn:schemas-microsoft-com:office:spreadsheet""
xmlns:html=""http://www.w3.org/TR/REC-html40"">
<DocumentProperties xmlns=""urn:schemas-microsoft-com:office:office"">
<Title>Moving Average EURUSD,H1 2018.01.01-2019.01.01</Title>
<Author>MetaQuotes Software Corp.</Author>
<Revision>1</Revision>
<Created>2019-05-18T17:38:08Z</Created>
<Company>Copyright 2000-2019, MetaQuotes Software Corp.</Company>
<Version>500</Version>
<Build>0</Build>
<Server>MetaQuotes-Demo</Server>
<Deposit>10000 USD</Deposit>
<Leverage>100</Leverage>
<Condition>0</Condition>
</DocumentProperties>
<Styles>
<Style ss:ID=""ce0""><NumberFormat ss:Format=""0""/></Style>
<Style ss:ID=""ce1""><NumberFormat ss:Format=""0.0""/></Style>
<Style ss:ID=""ce2""><NumberFormat ss:Format=""0.00""/></Style>
<Style ss:ID=""ce3""><NumberFormat ss:Format=""0.000""/></Style>
<Style ss:ID=""ce4""><NumberFormat ss:Format=""0.0000""/></Style>
<Style ss:ID=""ce5""><NumberFormat ss:Format=""0.00000""/></Style>
<Style ss:ID=""ce6""><NumberFormat ss:Format=""0.000000""/></Style>
<Style ss:ID=""ce7""><NumberFormat ss:Format=""0.0000000""/></Style>
<Style ss:ID=""ce8""><NumberFormat ss:Format=""0.00000000""/></Style>
<Style ss:ID=""ce11""><NumberFormat ss:Format=""Fixed""/></Style>
<Style ss:ID=""ce12""><NumberFormat ss:Format=""General Date""/></Style>
<Style ss:ID=""ce13""><NumberFormat ss:Format=""0.00000""/></Style>
</Styles>
<Worksheet ss:Name=""Tester Optimizator Results"">
<Table>
<Row>
<Cell><Data ss:Type=""String"">Pass</Data></Cell>
<Cell><Data ss:Type=""String"">Result</Data></Cell>
<Cell><Data ss:Type=""String"">Profit</Data></Cell>
<Cell><Data ss:Type=""String"">Expected Payoff</Data></Cell>
<Cell><Data ss:Type=""String"">Profit Factor</Data></Cell>
<Cell><Data ss:Type=""String"">Recovery Factor</Data></Cell>
<Cell><Data ss:Type=""String"">Sharpe Ratio</Data></Cell>
<Cell><Data ss:Type=""String"">Custom</Data></Cell>
<Cell><Data ss:Type=""String"">Equity DD %</Data></Cell>
<Cell><Data ss:Type=""String"">Trades</Data></Cell>
<Cell><Data ss:Type=""String"">MaximumRisk</Data></Cell>
<Cell><Data ss:Type=""String"">DecreaseFactor</Data></Cell>
<Cell><Data ss:Type=""String"">MovingPeriod</Data></Cell>
<Cell><Data ss:Type=""String"">MovingShift</Data></Cell>
</Row>
<Row>
<Cell><Data ss:Type=""Number"">4294967424</Data></Cell>
<Cell ss:StyleID=""ce2""><Data ss:Type=""Number"">10603.73</Data></Cell>
<Cell ss:StyleID=""ce2""><Data ss:Type=""Number"">603.73</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">8.749710</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">1.257785</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">0.434469</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">0.053446</Data></Cell>
<Cell><Data ss:Type=""Number"">0</Data></Cell>
<Cell ss:StyleID=""ce11""><Data ss:Type=""Number"">12.4021</Data></Cell>
<Cell><Data ss:Type=""Number"">69</Data></Cell>
<Cell><Data ss:Type=""Number"">0.046</Data></Cell>
<Cell><Data ss:Type=""Number"">4.5</Data></Cell>
<Cell><Data ss:Type=""Number"">90</Data></Cell>
<Cell><Data ss:Type=""Number"">48</Data></Cell>
</Row>
<Row>
<Cell><Data ss:Type=""Number"">4294967425</Data></Cell>
<Cell ss:StyleID=""ce2""><Data ss:Type=""Number"">3396.65</Data></Cell>
<Cell ss:StyleID=""ce2""><Data ss:Type=""Number"">-6603.35</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">-52.826800</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">0.629547</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">-0.821295</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">-0.093702</Data></Cell>
<Cell><Data ss:Type=""Number"">0</Data></Cell>
<Cell ss:StyleID=""ce11""><Data ss:Type=""Number"">72.3402</Data></Cell>
<Cell><Data ss:Type=""Number"">125</Data></Cell>
<Cell><Data ss:Type=""Number"">0.182</Data></Cell>
<Cell><Data ss:Type=""Number"">30.0</Data></Cell>
<Cell><Data ss:Type=""Number"">33</Data></Cell>
<Cell><Data ss:Type=""Number"">32</Data></Cell>
</Row>
<Row>
<Cell><Data ss:Type=""Number"">4294967426</Data></Cell>
<Cell ss:StyleID=""ce2""><Data ss:Type=""Number"">2374.64</Data></Cell>
<Cell ss:StyleID=""ce2""><Data ss:Type=""Number"">-7625.36</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">-95.317000</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">0.381214</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">-0.824397</Data></Cell>
<Cell ss:StyleID=""ce13""><Data ss:Type=""Number"">-0.246192</Data></Cell>
<Cell><Data ss:Type=""Number"">0</Data></Cell>
<Cell ss:StyleID=""ce11""><Data ss:Type=""Number"">80.2928</Data></Cell>
<Cell><Data ss:Type=""Number"">80</Data></Cell>
<Cell><Data ss:Type=""Number"">0.176</Data></Cell>
<Cell><Data ss:Type=""Number"">28.5</Data></Cell>
<Cell><Data ss:Type=""Number"">78</Data></Cell>
<Cell><Data ss:Type=""Number"">45</Data></Cell>
</Row>
</Table>
</Worksheet>
</Workbook>");
                file.Write(fileData, 0, fileData.Length);
            }

            reader = new ReportReader(ReportName);
        }
        [ClassCleanup]
        public static void ClearReport()
        {
            reader.Dispose();
            File.Delete(ReportName);
        }

        [TestMethod]
        public void Property_Test()
        {
            List<string> Columns_expected = new List<string>
            {
                "Pass","Result","Profit","Expected Payoff",
                "Profit Factor","Recovery Factor","Sharpe Ratio",
                "Custom","Equity DD %","Trades","MaximumRisk",
                "DecreaseFactor","MovingPeriod","MovingShift"
            };
            string Title_expected = "Moving Average EURUSD,H1 2018.01.01-2019.01.01";
            string Author_experted = "MetaQuotes Software Corp.";
            DateTime Created_expected = Convert.ToDateTime("2019-05-18T17:38:08");
            string Server_expected = "MetaQuotes-Demo";
            Deposit Deposit_expected = new Deposit(10000, "USD");
            int Leverage_expected = 100;

            List<string> Columns = reader.ColumnNames;
            string Title = reader.Title;
            string Author = reader.Author;
            DateTime Created = reader.Created;
            string Server = reader.Server;
            Deposit Deposit = reader.InitialDeposit;
            int Leverage = reader.Leverage;

            CollectionAssert.AreEqual(Columns_expected, Columns, "Columns are not the same");
            Assert.AreEqual(Title_expected, Title, "Title is different");
            Assert.AreEqual(Author_experted, Author, "Author is different");
            Assert.AreEqual(Created_expected, Created, "Created DT is different");
            Assert.AreEqual(Server_expected, Server, "Server is different");
            Assert.AreEqual($"{Deposit_expected.Value} {Deposit_expected.Currency}",
                            $"{Deposit.Value} {Deposit.Currency}", "Deposit is different");
            Assert.AreEqual(Leverage_expected, Leverage, "Leverage is different");
        }

        [TestMethod]
        public void Read_And_Reset_Test()
        {
            List<KeyValuePair<string, object>>[] expected = new List<KeyValuePair<string, object>>[3]
            {
                new List<KeyValuePair<string, object>>
                {
                    new KeyValuePair<string, object>("Pass",4294967424.0),
                    new KeyValuePair<string, object>("Result", 10603.73),
                    new KeyValuePair<string, object>("Profit", 603.73),
                    new KeyValuePair<string, object>("Expected Payoff",8.749710),
                    new KeyValuePair<string, object>("Profit Factor",1.257785),
                    new KeyValuePair<string, object>("Recovery Factor",0.434469),
                    new KeyValuePair<string, object>("Sharpe Ratio",0.053446),
                    new KeyValuePair<string, object>("Custom",0.0),
                    new KeyValuePair<string, object>("Equity DD %",12.4021),
                    new KeyValuePair<string, object>("Trades",69.0),
                    new KeyValuePair<string, object>("MaximumRisk",0.046),
                    new KeyValuePair<string, object>("DecreaseFactor",4.5),
                    new KeyValuePair<string, object>("MovingPeriod",90.0),
                    new KeyValuePair<string, object>("MovingShift",48.0)
                },
                new List<KeyValuePair<string, object>>
                {
                    new KeyValuePair<string, object>("Pass",4294967425.0),
                    new KeyValuePair<string, object>("Result", 3396.65),
                    new KeyValuePair<string, object>("Profit", -6603.35),
                    new KeyValuePair<string, object>("Expected Payoff",-52.826800),
                    new KeyValuePair<string, object>("Profit Factor",0.629547),
                    new KeyValuePair<string, object>("Recovery Factor",-0.821295),
                    new KeyValuePair<string, object>("Sharpe Ratio",-0.093702),
                    new KeyValuePair<string, object>("Custom",0.0),
                    new KeyValuePair<string, object>("Equity DD %",72.3402),
                    new KeyValuePair<string, object>("Trades",125.0),
                    new KeyValuePair<string, object>("MaximumRisk",0.182),
                    new KeyValuePair<string, object>("DecreaseFactor",30.0),
                    new KeyValuePair<string, object>("MovingPeriod",33.0),
                    new KeyValuePair<string, object>("MovingShift",32.0)
                },
                new List<KeyValuePair<string, object>>
                {
                    new KeyValuePair<string, object>("Pass",4294967426.0),
                    new KeyValuePair<string, object>("Result", 2374.64),
                    new KeyValuePair<string, object>("Profit", -7625.36),
                    new KeyValuePair<string, object>("Expected Payoff",-95.317000),
                    new KeyValuePair<string, object>("Profit Factor",0.381214),
                    new KeyValuePair<string, object>("Recovery Factor",-0.824397),
                    new KeyValuePair<string, object>("Sharpe Ratio",-0.246192),
                    new KeyValuePair<string, object>("Custom",0.0),
                    new KeyValuePair<string, object>("Equity DD %",80.2928),
                    new KeyValuePair<string, object>("Trades",80.0),
                    new KeyValuePair<string, object>("MaximumRisk",0.176),
                    new KeyValuePair<string, object>("DecreaseFactor",28.5),
                    new KeyValuePair<string, object>("MovingPeriod",78.0),
                    new KeyValuePair<string, object>("MovingShift",45.0)
                }
            };

            void DoTest()
            {
                int i = 0;
                while (reader.Read(out List<KeyValuePair<string, object>> data))
                {
                    CollectionAssert.AreEqual(expected[i], data, comparer, $"Collection at the index {i} is different");
                    i++;
                }
            }

            DoTest();
            reader.ResetReader();
            DoTest();
        }

    }

    class Comparer_Report : System.Collections.IComparer
    {
        public int Compare(object x, object y)
        {
            KeyValuePair<string, object> _x = (KeyValuePair<string, object>)x;
            KeyValuePair<string, object> _y = (KeyValuePair<string, object>)y;

            string __x = $"{_x.Key}={_x.Value}";
            string __y = $"{_y.Key}={_y.Value}";

            return __x.CompareTo(__y);
        }
    }
}
